;------------------------------------------------------------------------------
;				
;------------------------------------------------------------------------------
CPUUpdate:
	jsr	AddCPU
	jsr	MoveCPU

	rts
;------------------------------------------------------------------------------
;				
;------------------------------------------------------------------------------
MoveCPU:
	ldx	<max_sprite
;-------------------------------------- Ẍړ
.move_cpu:
	ldy	chara.exist, x
	dey
	bne	.move_cpu_end

	lda	chara.lrflag, x
	beq	.move_left
.move_right:
	inc	chara.dotx, x
	lda	chara.dotx, x
	sub	#$F0
	bcc	.move_y

	lda	#$00
	sta	chara.lrflag, x
	jmp	.move_y
.move_left:
	dec	chara.dotx, x
	bne	.move_y

	lda	#$01
	sta	chara.lrflag, x
;-------------------------------------- Ÿړ
.move_y:
	jsr	GetRandom
	and	#$01
	beq	.move_cpu_end

	inc	chara.doty, x
	lda	chara.doty, x
	cmp	#$B8
	bne	.move_cpu_end

	lda	#$00
	sta	chara.exist, x
.move_cpu_end:
	dex
	bne	.move_cpu

	rts
;------------------------------------------------------------------------------
;				
;------------------------------------------------------------------------------
AddCPU:
	ldx	#$01
.search_blank:
	lda	chara.exist, x
	beq	.find_blank

	inx
	cpx	<max_sprite
	bne	.search_blank
.notfind_blank:

	rts
	
.find_blank:
	jsr	GetRandom
	and	#$03

	ldy	max_valiation
	beq	.val0
	dey
	beq	.val1
	dey
	beq	.val2
	dey
	beq	.val3
.val0:
	lda	#$00
	jmp	.load_cpu
.val1:
	and	#$01
	jmp	.load_cpu
.val2:
	cmp	#$03
	bne	.load_cpu

	lda	#$00
	jmp	.load_cpu
.val3:
	jmp	.load_cpu
.load_cpu:
	sta	chara.type, x
	tay
	lda	cpu_pattern_table, y
	sta	chara.pattern, x
	lda	cpu_color_table, y
	sta	chara.color, x
	lda	cpu_enagy_table, y
	sta	chara.enagy, x
	lda	cpu_score_table, y
	sta	chara.score, x
	
	jsr	GetRandom
	sta	chara.dotx, x
	lda	#$00
	sta	chara.doty, x
	lda	#$01
	sta	chara.exist, x
	lda	#$60
	sta	chara.shotblank, x

	rts
;------------------------------------------------------------------------------
;				
;------------------------------------------------------------------------------
cpu_pattern_table:
	.DB	$02, $03, $02, $03
	
cpu_color_table:
	.DB	$01, $01, $02, $02

cpu_enagy_table:
	.DB	$01, $02, $01, $02

cpu_score_table:
	.DB	$05, $0E, $12, $23
