;##############################################################################
;
;			@@FCTEhhCo
;
;##############################################################################

;------------------------------------------------------------------------------
;				APU
;------------------------------------------------------------------------------
APUInit:
	lda	#$1F
	sta	$4015		; APUe`lL

	ldx	bgm_world + 1
	ldy	bgm_world
	stx	point1 + 1
	sty	point1
	jsr	SetMusicPoint

	rts
;------------------------------------------------------------------------------
;				yf[^Zbg
;------------------------------------------------------------------------------
SetMusicPoint:
	ldx	point1 + 1
	ldy	point1
	stx	<bgm.start + 1
	sty	<bgm.start
	stx	<bgm.address + 1
	sty	<bgm.address

	lda	#$04
	sta	bgm.sync_lenth

	lda	#$00
	sta	$4001
	sta	$4005

	lda	#$30
	sta	bgm.note1_flag
	sta	bgm.note2_flag

	rts
;------------------------------------------------------------------------------
;				BGMĐ
;------------------------------------------------------------------------------
PlayBGM:
	lda	<reg1
	pha
	jsr	PlayBGMMain
	pla
	sta	<reg1

	rts
;------------------------------------------------------------------------------
;				BGMĐ
;------------------------------------------------------------------------------
PlayBGMMain:
	jsr	NotePlayEffect
;-------------------------------------- BGM`FbN
.sync_count:
	inc	bgm.sync_count
	lda	bgm.sync_count
	cmp	bgm.sync_lenth
	beq	.bgm_main
	rts

.bgm_main:
	lda	#$00
	sta	bgm.sync_count
;-------------------------------------- ߂̓ǂݍ1
	ldy	#$00
	lda	[bgm.address], y
	php
	incw	<bgm.address
	plp
	beq	.wait			; 00
	tax
	dex
	beq	.load_note1
	dex
	beq	.load_note2
	dex
	beq	.load_note3
	dex
	beq	.load_note4
	dex
	beq	.load_note5
	dex
	beq	.stop_note1
	dex
	beq	.stop_note2
	cmp	#$FF
	beq	.dacapo			; FF

	jmp	.load_function2
;--------------------------- EFCg($00)
.wait:
	lda	[bgm.address], y
	sta	bgm.sync_lenth
	incw	<bgm.address
	rts
;---------------------------- `g1m[g[h($01)
.load_note1:
	ldx	#$00
	jsr	NoteOutRec
	jmp	.bgm_main
;---------------------------- `g2m[g[h($02)
.load_note2:
	ldx	#$04
	jsr	NoteOutRec
	jmp	.bgm_main
;---------------------------- Opgm[g[h($03)
.load_note3:
	jsr	NoteOutTri
	jmp	.bgm_main
;---------------------------- mCYm[g[h($04)
.load_note4:
	jsr	NoteOutNoise
	jmp	.bgm_main
;---------------------------- DPCMm[g[h($05)
.load_note5:
	jsr	NoteOutDPCM
	jmp	.bgm_main
;---------------------------- m[g1Xgbv($06)
.stop_note1:
	lda	#$FF
	sta	bgm.note1_data
	lda	#$00
	sta	$4000
	jmp	.bgm_main
;---------------------------- m[g2Xgbv($07)
.stop_note2:
	lda	#$FF
	sta	bgm.note2_data
	lda	#$00
	sta	$4004
	jmp	.bgm_main
;---------------------------- _J[|($FF)
.dacapo:
	ldx	<bgm.start + 1
	ldy	<bgm.start
	stx	<bgm.address + 1
	sty	<bgm.address
	jmp	.bgm_main
;-------------------------------------- Wvpn_
.jmp_center:
	jmp	.bgm_main
;-------------------------------------- ߂̓ǂݍ2
.load_function2:
	sub	#$10
	tax
	beq	.change_tone1
	dex
	beq	.change_tone2
	dex
	beq	.change_vol1
	dex
	beq	.change_vol2
	dex
	beq	.change_env1
	dex
	beq	.change_env2
	dex
	beq	.change_soft1
	dex
	beq	.change_soft2
	dex
	beq	.change_vib1
	dex
	beq	.change_vib2
	dex
	beq	.change_vib3
	jmp	.jmp_center
;---------------------------- m[g1FύX($10)
.change_tone1:
	ldx	#$00
	jsr	ChangeTone
	jmp	.jmp_center
;---------------------------- m[g2FύX($11)
.change_tone2:
	ldx	#$04
	jsr	ChangeTone
	jmp	.jmp_center
;---------------------------- m[g1{[ύX($12)
.change_vol1:
	ldx	#$00
	jsr	ChangeVolume
	jmp	.jmp_center
;---------------------------- m[g2{[ύX($13)
.change_vol2:
	ldx	#$04
	jsr	ChangeVolume
	jmp	.jmp_center
;---------------------------- m[g1Gx[utOύX($14)
.change_env1:
	lda	[bgm.address], y
	sta	bgm.note1_env
	incw	<bgm.address
	jmp	.jmp_center
;---------------------------- m[g2Gx[utOύX($15)
.change_env2:
	lda	[bgm.address], y
	sta	bgm.note2_env
	incw	<bgm.address
	jmp	.jmp_center
;---------------------------- m[g1\tgtOύX($16)
.change_soft1:
	lda	[bgm.address], y
	sta	bgm.note1_soft
	incw	<bgm.address
	jmp	.jmp_center
;---------------------------- m[g2\tgtOύX($17)
.change_soft2:
	lda	[bgm.address], y
	sta	bgm.note2_soft
	incw	<bgm.address
	jmp	.jmp_center
;---------------------------- m[g1ru[gtOύX($18)
.change_vib1:
	lda	[bgm.address], y
	sta	bgm.note1_vib
	incw	<bgm.address
	jmp	.jmp_center
;---------------------------- m[g1ru[gtOύX($19)
.change_vib2:
	lda	[bgm.address], y
	sta	bgm.note2_vib
	incw	<bgm.address
	jmp	.jmp_center
;---------------------------- m[g1ru[gtOύX($1A)
.change_vib3:
	lda	[bgm.address], y
	sta	bgm.note3_vib
	incw	<bgm.address
	jmp	.jmp_center
;-------------------------------------- Tu[`I

	rts
;------------------------------------------------------------------------------
;			m[g̍ĐԃJEg
;------------------------------------------------------------------------------
NotePlayEffect:
	lda	#$00
	sta	$400E

	ldx	#$00
	jsr	NoteEffectRec		; `g1GtFNg
	ldx	#$04
	jsr	NoteEffectRec		; `g2GtFNg
;-------------------------------------- OpgGtFNg
	ldx	bgm.note3_data
	inx
	beq	.end
	ldx	#$08
	jsr	NoteEffectVib

	inc	bgm.note3_count
	lda	bgm.note3_count
	cmp	bgm.note3_lenth
	beq	.note3_stop
	jmp	.end
.note3_stop:
	lda	#$00
	sta	$4008
	lda	#$FF
	sta	bgm.note3_data
.end:

	rts
;------------------------------------------------------------------------------
;			`gp[g̃m[go͖
;------------------------------------------------------------------------------
NoteOutRec:
	lda	bgm.note1_flag, x
	and	#$F0
	ora	bgm.note1_vol, x
	sta	bgm.note1_flag, x

	lda	bgm.note1_soft, x
	bne	.set_soft_note

	lda	bgm.note1_flag, x
	sta	$4000, x
	jmp	.put_note
.set_soft_note:
	lda	bgm.note1_flag, x
	sub	#$04
	sta	$4000, x
.put_note:
	lda	#$00
	sta	bgm.note1_count, x
	sta	bgm.note1_countcflag, x
	sta	bgm.note1_efflag, x

	ldy	#$00
	lda	[bgm.address], y
	sta	bgm.note1_data, x
	tay
	lda	note_under, y
	sta	$4002, x
	lda	note_above, y
	sta	$4003, x

	incw	<bgm.address
	ldy	#$00
	lda	[bgm.address], y
	sta	bgm.note1_lenth, x
	incw	<bgm.address

	rts
;------------------------------------------------------------------------------
;			Opgp[g̃m[go͖
;------------------------------------------------------------------------------
NoteOutTri:
	lda	#$8F
	sta	$4008

	lda	#$00
	sta	bgm.note3_count
	sta	bgm.note3_efflag

	lda	[bgm.address], y
	sta	bgm.note3_data
	tax
	lda	note_under, x
	sta	$400A
	lda	note_above, x
	ora	#$F0
	sta	$400B

	incw	<bgm.address
	lda	[bgm.address], y
	sta	bgm.note3_lenth

	incw	<bgm.address

	rts
;------------------------------------------------------------------------------
;			mCYp[g̃m[go͖
;------------------------------------------------------------------------------
NoteOutNoise:
	lda	#$06
	sta	$400C
	lda	[bgm.address], y
	lda	#$02
	sta	$400E

	lda	#$00
	sta	$400F
	incw	<bgm.address

	rts
;------------------------------------------------------------------------------
;			DPCMp[g̃m[go͖
;------------------------------------------------------------------------------
NoteOutDPCM:
	lda	#$0F
	sta	$4015

	lda	[bgm.address], y
	asl	a
	asl	a
	tax

	lda	dram_table, x
	sta	$4010
	lda	dram_table + 1, x
	sta	$4011
	lda	dram_table + 2, x
	sta	$4012
	lda	dram_table + 3, x
	sta	$4013

	lda	#$1F
	sta	$4015

	incw	<bgm.address

	rts
;------------------------------------------------------------------------------
;			`gp[g̃GtFNg
;------------------------------------------------------------------------------
NoteEffectRec:
;-------------------------------------- `gp[gĐԃ`FbN
	ldy	bgm.note1_data, x
	iny
	bne	.start_effect
	rts

.start_effect:
	inc	bgm.note1_count, x
	bne	.check_count
	lda	#$01
	sta	bgm.note1_countcflag, x

.check_count:
	lda	bgm.note1_flag, x
	and	#$0F
	bne	.check_soft

	lda	#$FF
	sta	bgm.note1_data, x
	lda	bgm.note1_flag, x
	and	#$F0
	sta	$4000, x

	rts
;---------------------------- `gp[gGtFNgt
.check_soft:
	lda	bgm.note1_soft, x
	beq	.check_hit
	jsr	NoteEffectSoft		; \tgGtFNg

.check_hit:
	lda	bgm.note1_tone, x
	sub	#$04
	bcc	.check_vib
	jsr	NoteEffectHit		; qbgGtFNg

.check_vib:
	lda	bgm.note1_vib, x
	beq	.effect_env_start
	jsr	NoteEffectVib		; ru[gGtFNg
;---------------------------- `gp[gc
.effect_env_start:
	lda	bgm.note1_countcflag, x
	bne	.effect_env

	lda	bgm.note1_lenth, x
	sub	bgm.note1_count, x
	bcc	.effect_env		; ̒=JE^Ŏc
	jmp	.end

.effect_env:
	jsr	NoteEffectEnv
	jmp	.end
.end:

	rts
;------------------------------------------------------------------------------
;			Opgp[g̃ru[gGtFNg
;------------------------------------------------------------------------------
NoteEffectVib:
	lda	bgm.note1_count, x
	sub	#$28
	bcs	.start

	rts
.start:
	lda	bgm.note1_efflag, x
	cmp	#$00
	beq	.vib_inc
	cmp	#$03
	beq	.vib_default
	cmp	#$06
	beq	.vib_dec
	cmp	#$09
	beq	.vib_default
	cmp	#$0B
	beq	.vib_reset
	jmp	.end

	ldy	bgm.note1_efflag, x
	beq	.vib_inc
;-------------------------------------- ru[g
.vib_dec:
	ldy	bgm.note1_data, x
	lda	note_under, y
	add	#$01
	sta	$4002, x
	jmp	.end
;-------------------------------------- ru[gグ
.vib_inc:
	ldy	bgm.note1_data, x
	lda	note_under, y
	sub	#$01
	sta	$4002, x
	jmp	.end
;-------------------------------------- ru[gfBtHg
.vib_default:
	ldy	bgm.note1_data, x
	lda	note_under, y
	sta	$4002, x
	jmp	.end
;-------------------------------------- ru[gJEgZbg
.vib_reset:
	lda	#$FF
	sta	bgm.note1_efflag, x
.end:
	inc	bgm.note1_efflag, x

	rts
;------------------------------------------------------------------------------
;			`gp[g̃Gx[vGtFNg
;------------------------------------------------------------------------------
NoteEffectEnv:
	lda	bgm.note1_env, x
	beq	.stop
	tay
	dey
	beq	.start_env

	lda	bgm.note1_count, x
.env_cycle:
	lsr	a
	bcc	.end
	dey
	bne	.env_cycle

.start_env:
	lda	bgm.note1_flag, x
	and	#$0F
	tay
	dey
	sty	<reg1
	lda	bgm.note1_flag, x
	and	#$F0
	ora	<reg1
	sta	bgm.note1_flag, x
	sta	$4000, x
	jmp	.end
.stop:
	lda	#$00
	sta	bgm.note1_data, x
	sta	$4002, x
	sta	$4003, x
.end:

	rts
;------------------------------------------------------------------------------
;			`gp[g̃\tgGtFNg
;------------------------------------------------------------------------------
NoteEffectSoft:
	lda	bgm.note1_count, x
	sub	#$04
	bcs	.end

	lda	bgm.note1_flag, x
	sub	#$01
	sta	$4000, x
.end:

	rts
;------------------------------------------------------------------------------
;			`gp[g̒eGtFNg
;------------------------------------------------------------------------------
NoteEffectHit:
	lda	bgm.note1_count, x
	tay
	dey
	dey
	dey
	beq	.start_hit
	jmp	.end

.start_hit:
	lda	bgm.note1_flag, x
	tay
	and	#$F0
	sta	<reg1
	tya
	and	#$0F
	lsr	a
	ora	<reg1
	sta	$4000, x
	sta	bgm.note1_flag, x
.end:

	rts
;------------------------------------------------------------------------------
;			`gp[g̃{[ύX
;------------------------------------------------------------------------------
ChangeVolume:
	ldy	#$00
	lda	[bgm.address], y
	sta	bgm.note1_vol, x

	lda	bgm.note1_flag, x
	and	#$F0
	ora	bgm.note1_vol, x
	sta	bgm.note1_flag, x

	incw	<bgm.address

	rts
;------------------------------------------------------------------------------
;			`gp[g̉FύX
;------------------------------------------------------------------------------
ChangeTone:
	ldy	#$00
	lda	[bgm.address], y
	sta	bgm.note1_tone, x
	tay
	lda	tone_table, y
	sta	<reg1
	lda	bgm.note1_flag, x
	and	#$0F
	ora	<reg1
	sta	bgm.note1_flag, x

	incw	<bgm.address

	rts
;------------------------------------------------------------------------------
;			Fł$4000or$4004e[u
;------------------------------------------------------------------------------
tone_table:
	.DB	%00110000, %01110000, %10110000, %11110000
	.DB	%00110000, %01110000, %10110000, %11110000
	.DB	%00110000, %01110000, %10110000, %11110000
;------------------------------------------------------------------------------
;			e[u3rbg
;------------------------------------------------------------------------------
note_above:
	.DB	$06, $06, $05, $05, $05, $04, $04, $04, $04, $03, $03, $03, $00, $00, $00, $00
	.DB	$03, $03, $02, $02, $02, $02, $02, $02, $02, $01, $01, $01, $00, $00, $00, $00
	.DB	$01, $01, $01, $01, $01, $01, $01, $01, $01, $00, $00, $00, $00, $00, $00, $00
	.DB	$00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
	.DB	$00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
	.DB	$00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
	.DB	$00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00, $00
;------------------------------------------------------------------------------
;			e[u8rbg
;------------------------------------------------------------------------------
note_under:
	.DB	$98, $38, $E2, $8C, $3F, $F3, $AC, $6C, $2C, $EF, $B8, $84, $00, $00, $00, $00
	.DB	$52, $21, $F6, $CA, $A3, $7D, $59, $39, $18, $FA, $DE, $C4, $00, $00, $00, $00
	.DB	$AB, $92, $7C, $66, $53, $3F, $2D, $1D, $0C, $FD, $EF, $E2, $00, $00, $00, $00
	.DB	$D5, $C9, $BE, $B3, $A9, $A0, $96, $8E, $86, $7E, $77, $71, $00, $00, $00, $00
	.DB	$6A, $63, $5E, $58, $53, $4F, $4A, $46, $42, $3E, $3A, $37, $00, $00, $00, $00
	.DB	$35, $32, $2F, $2C, $2A, $28, $25, $23, $21, $1F, $1E, $1B, $00, $00, $00, $00
	.DB	$1A, $18, $17, $16, $15, $14, $12, $11, $10, $0F, $0E, $0D, $00, $00, $00, $00
;------------------------------------------------------------------------------
;				he[u
;------------------------------------------------------------------------------
dram_table:
	.DB	$0F, $00, $00, $50
	.DB	$0F, $00, $14, $50
