;------------------------------------------------------------------------------
;			@	PPU
;------------------------------------------------------------------------------
PPUInit:
	lda	#%11101000
	sta	screen.flag
	sta	$2000

	rts
;------------------------------------------------------------------------------
;			@	VSYNCEFCg
;------------------------------------------------------------------------------
Vsync:
	lda	<retrace_count
	sta	<retrace_countold

	lda	$2002
.wait:
	lda	$2002
	bpl	.wait

	rts
;------------------------------------------------------------------------------
;			ʂtbV(Vsynct)
;------------------------------------------------------------------------------
Refresh:
	pha
	txa
	pha
	tya
	pha

	ldx	game_mode
	inx
	beq	.inc_retrace
;--------------------------------------
.inc_retrace:
	ldx	<retrace_count
	dex
	cpx	<retrace_countold
	beq	.end

	jsr	PlayBGM
.end:
	jsr	Vsync
	lda	#%00011110
	sta	$2001

	pla
	tay
	pla
	tax
	pla

	rts
;------------------------------------------------------------------------------
;			XWYWVRAMAhX֕ϊ
; input		a : y[W
;		x : XW
;		y : YW
; output	x : VRAMAhX8bit	
;		y : VRAMAhX8bit
;------------------------------------------------------------------------------
SetVramAddress:
	sta	<a_cash
	lda	<reg1
	pha
	lda	<reg2
	pha
	lda	<reg3
	pha
	lda	<reg4
	pha

	lda	<a_cash
	sta	<reg1		; reg1 = l[y[W
	stx	<reg2		; reg2 = wW
	sty	<reg3		; reg3 = xW
	lda	#$00
	sta	<reg4		; reg4 = reg3 * #$20 ̂ӂꌅ

	ldy	#$05
.loop:
	asl	<reg3
	php
	lda	<reg4
	asl	a
	plp
	adc	#$00
	sta	<reg4
	dey
	bne	.loop

	lda	<reg1
	asl	a
	asl	a
	add	#$20
	add	<reg4
	tax
	lda	<reg3
	add	<reg2
	tay

	pla
	sta	<reg4
	pla
	sta	<reg3
	pla
	sta	<reg2
	pla
	sta	<reg1

	rts
;------------------------------------------------------------------------------
;			ʂ̃XN[ݒ
;------------------------------------------------------------------------------
SetScroll:
	lda	<screen.x
	sta	$2005
	lda	<screen.y
	sta	$2005

	rts
;------------------------------------------------------------------------------
;				tF[hC
;------------------------------------------------------------------------------
FadeIn:
	ldx	#$20
	ldy	#$00
.start_copy:
	lda	tb_game_palette, y
	sta	tb_palette_cash, y
	iny
	dex
	bne	.start_copy	
;-------------------------------------- tF[hC
	ldy	#$04
.main_loop:
	tya
	pha

	jsr	Refresh
	jsr	Refresh
	jsr	Refresh

	lda	#$3F
	sta	$2006
	lda	#$00
	sta	$2006

	lda	screen.flag
	sta	$2000

	ldx	#$20
	ldy	#$00
.write:
	lda	tb_palette_cash, y
	sub	#$10
	bcc	.write_black

	sta	$2007
	sta	tb_palette_cash, y
	jmp	.write_end
.write_black:
	lda	#$0F
	sta	$2007
	sta	tb_palette_cash, y
.write_end:
	iny
	dex
	bne	.write
	jsr	SetScroll

	pla
	tay
	dey
	bne	.main_loop

	rts
;------------------------------------------------------------------------------
;				tF[hAEg
;------------------------------------------------------------------------------
FadeOut:
	jsr	PaletteClear

	ldy	#$20
.copy:
	lda	tb_game_palette, y
	sub	#$40
	sta	tb_palette_cash, y
	dey
	bne	.copy
;-------------------------------------- tF[hAEg
	ldy	#$00
.main_loop:
	tya
	pha

	jsr	Refresh
	jsr	Refresh
	jsr	Refresh

	lda	#$3F
	sta	$2006
	lda	#$00
	sta	$2006

	lda	screen.flag
	sta	$2000

	ldy	#$00
.write:
	lda	tb_palette_cash, y
	add	#$10
	sta	tb_palette_cash, y
	sub	#$40
	bcs	.write_black

	lda	tb_palette_cash, y
	sta	$2007
	jmp	.write_end
.write_black:
	lda	#$0F
	sta	$2007
.write_end:
	iny
	cpy	#$20
	bne	.write

	jsr	SetScroll
	pla
	tay
	iny
	cpy	#$04
	bne	.main_loop

	rts
;------------------------------------------------------------------------------
;			Q[pbgZbg
;------------------------------------------------------------------------------
SetPalette:
	jsr	Refresh
	lda	#$3F
	sta	$2006
	lda	#$00
	sta	$2006

	lda	screen.flag
	sta	$2000

	ldy	#$00
.main_loop:
	lda	tb_game_palette, y
	sta	$2007
	iny
	cpy	#$20
	bne	.main_loop

	jsr	SetScroll

	rts
;------------------------------------------------------------------------------
;				pbgNA
;------------------------------------------------------------------------------
PaletteClear:
	jsr	Refresh
	lda	#$3F
	sta	$2006
	lda	#$00
	sta	$2006

	lda	screen.flag
	sta	$2000

	ldx	#$20
	ldy	#$00
.main_loop:
	lda	#$0D
	sta	$2007
	iny
	dex
	bne	.main_loop
	jsr	SetScroll

	rts
